var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var Rule = (function (_super) {
    __extends(Rule, _super);
    function Rule() {
        _super.apply(this, arguments);
    }
    Rule.prototype.apply = function (syntaxTree) {
        return this.applyWithWalker(new NoConstructorVariableDeclarationsWalker(syntaxTree, this.getOptions()));
    };
    Rule.FAILURE_STRING_PART = " cannot be declared in the constructor";
    return Rule;
})(Lint.Rules.AbstractRule);
exports.Rule = Rule;

var NoConstructorVariableDeclarationsWalker = (function (_super) {
    __extends(NoConstructorVariableDeclarationsWalker, _super);
    function NoConstructorVariableDeclarationsWalker() {
        _super.apply(this, arguments);
    }
    NoConstructorVariableDeclarationsWalker.prototype.visitConstructorDeclaration = function (node) {
        var position = this.positionAfter(node.modifiers, node.constructorKeyword, node.parameterList.openParenToken);
        var list = node.parameterList.parameters;
        for (var i = 0; i < list.childCount(); i++) {
            var element = list.childAt(i);
            if (element.kind() !== 242 /* Parameter */) {
                position += element.fullWidth();
                continue;
            }
            var parameter = element;
            if (parameter.modifiers.childCount() > 0) {
                this.addFailure(this.createFailure(position, parameter.modifiers.fullWidth(), "'" + parameter.identifier.text() + "'" + Rule.FAILURE_STRING_PART));
            }
            position += parameter.fullWidth();
        }
        _super.prototype.visitConstructorDeclaration.call(this, node);
    };
    return NoConstructorVariableDeclarationsWalker;
})(Lint.RuleWalker);
exports.NoConstructorVariableDeclarationsWalker = NoConstructorVariableDeclarationsWalker;
